#ifndef _FILE_H
#define _FILE_H
#include "ystring.h"

void setBinaryIO();
int valid_fdl(PVStr(vfd));

FILE *TMPFILE(PCStr(what));
FILE *TMPFILEX(PVStr(path));
FILE *NULLFP();
int   openNull(int rw);
void  freeTmpFile(PCStr(what));
FILE *getTmpFile(PCStr(what));
const char *getTMPDIR();
FILE *reusableTMPFILE(PCStr(what),iFUNCP where);


typedef int (*scanDirCallP)(PCStr(elem),...);
#define scanDirFunc int
#define scanDirCall (scanDirCallP)
int   Scandir(PCStr(dirpath),scanDirCallP,...);

int   Ftruncate(FILE *fp,int offset,int whence);
char *FileModes(int);
void  setTMPDIR(PCStr(dir));
int   fcompare(FILE *fp1,FILE *fp2);

int file_is(int fd);
int file_isreg(int);
int file_isfifo(int fd);
int file_issock(int fd);
int file_ISSOCK(int fd);
int file_stat(int fd,int *sizep,int *mtimep,int *atimep);
int file_mtime(int fd);
int file_size(int);
int file_uid(int fd);
int file_ino(int fd);
int file_cmp(int fd1,int fd2);
int file_nlink(int fd);
int file_timeoff(int fd,int created_now);

int fileIsdir(PCStr(path));
int fileIsflat(PCStr(path));
int File_is(PCStr(path));
int File_isreg(PCStr(path));
int File_stats(PCStr(path),int,int*,int*,int*,int*,int*);
int File_stat(PCStr(path),int *size,int *time,int *isdir);
int File_sizetime(PCStr(path),int *fsize,int *ctime,int *mtime,int *atime);
int File_mtime(PCStr(path));
int File_ctime(PCStr(path));
int File_size(PCStr(path));
int File_copymod(PCStr(src),PCStr(dst));
int File_cmp(PCStr(path1),PCStr(path2));
int File_ino(PCStr(path));
int File_uid(PCStr(path));

int isBoundpath(PCStr(path));
int isFullpath(PCStr(path));
int access_RWX(PCStr(path));

void setOWNER(PCStr(dir),int uid,int gid);
int  set_utimes(PCStr(path),int atime,int mtime);
void File_touch(PCStr(path),int clock);
void ftouch(FILE *fp,int time);

int lock_exclusiveNB(int fd);
int lock_exclusiveTO(int fd,int timeout,int *elapsedp);
int lock_exclusive(int fd);
int lock_sharedNB(int fd);
int lock_sharedTO(int fd,int timeout,int *elapsedp);
int lock_shared(int fd);
int lock_unlock(int fd);

FILE *fopenShared(PCStr(path),PCStr(mode));
void  chmodShared(PCStr(path));
int   chmodIfShared(PCStr(path),int);
int   mkdirShared(PCStr(dir),int mode);
int   setSHARE(PCStr(pathpat));

int   Fwrite(PCStr(buf),int esize,int ecount,FILE *fp);
char *Fgets(PVStr(buf),int size,FILE *fp);
int   Fputs(PCStr(str),FILE *fp);
char *freadfile(FILE *fp,int *sizep);
int   copyfile1(FILE*,FILE*);

int RecvPeek(int sock,void *buf,int len);
int reads(int fd,PVStr(buf),int len);
int readsTO(int fd,PVStr(buf),int len,int timeout);

int   FullpathOfExe(PVStr(path));
void  path_escchar(PVStr(path));
FILE *fopen_PATH(const char *pathv[],PCStr(file),PCStr(mode),PVStr(xpath));
FILE *fopen_LIBPATH(PCStr(file),PCStr(mode),PVStr(xpath));
const char **vect_PATH(PCStr(path));
void  chdir_cwd(PVStr(cwd),PCStr(go),int userdir);

typedef struct stat *StP;
void dir2ls(PCStr(dirpath),StP stp,PCStr(opt),xPVStr(fmt),FILE *fp);
FILE *ls_unix(FILE *fp,PCStr(opt),PVStr(fmt),PCStr(dir),StP stp);

#endif /* _FILE_H */
