#ifdef _MSC_VER
#include <windows.h>
#include <stdio.h>
#include "ystring.h"

typedef struct {
	IFUNCP	 th_func;
	char	*th_av[8]; /**/
} threadEntry;

static void thread1(threadEntry *th)
{	int rcode;
	char **av = th->th_av;

	rcode = (*(th->th_func))(av[0],av[1],av[2],av[3],av[4],av[5],av[6]);
	porting_dbg("thread exit(%d)",rcode);
	free(th);
	ExitThread(rcode);
}

static int thread_fork(int ssize,IFUNCP func,...)
{	DWORD tid;
	HANDLE thandle;
	threadEntry *th;
	int ai;
	VARGS(7,func);

	porting_dbg("thread fork(%d,%x) --> CreateThread()",ssize,func);

	th = (threadEntry*)malloc(sizeof(threadEntry));
	th->th_func = func;
	for( ai = 0; ai < 7; ai++ )
		th->th_av[ai] = va[ai];

	thandle = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)thread1,th,0,&tid);
	porting_dbg("thread fork(%x / %d)",th->th_func,tid);
	return tid;
}

const char *WithThread = "CreateThread";
int (*ThreadFork)(int,IFUNCP,...) = thread_fork;
int (*ThreadYield)() = 0;
void WINthread(){}
#else
static int dummy;
#endif
